/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: ProgressiveRuleBase.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_PROGRESSIVE_RULE_BASE_HPP_
#define _TOPS_PROGRESSIVE_RULE_BASE_HPP_

#include "tops/common/Printable.hpp"
#include "tops/system/progressive/ProgressiveRule.hpp"

#include <map>
// #include "tops/utilities/CloseMap.hpp"

#include <string>

namespace tops {

	/**
	 * 進行性ルールベースです。
	 *
	 * @author トゥイー
	 */
	class ProgressiveRuleBase : public Printable {
	private:
		typedef std::multimap<std::string, ProgressiveRulePtr> ProgressiveRuleMap;
		// TODO(2004/12/10): CloseMap クラスに upperBound とか範囲に関係するメソッドを実装する必要がある。
		// typedef Utility::CloseMap<std::string, ProgressiveRulePtr> ProgressiveRuleMap;

		/**
		 * 進行待ち条件名によって参照可能なルールマップです。
		 */
		ProgressiveRuleMap m_ruleMap;

	public:
		typedef ProgressiveRuleMap::iterator mapIterator;
		typedef ProgressiveRuleMap::const_iterator const_mapIterator;

	public:
		/**
		 * 空かどうかを判断します。
		 *
		 * @return 空だったらtrueを、空じゃなかったらfalseを返します。
		 */
		bool empty() const;

		/**
		 * サイズを取得します。
		 */
		size_t size() const;

		/**
		 * 進行性プロダクションルールを追加します。
		 */
		void add(const ProgressiveRulePtr& rule);

	public:
		mapIterator begin() {
			return m_ruleMap.begin();
		}

		const_mapIterator begin() const {
			return m_ruleMap.begin();
		}

		mapIterator end() {
			return m_ruleMap.end();
		}

		const_mapIterator end() const {
			return m_ruleMap.end();
		}

	public:
		/**
		 * 進行待ち条件名で要素を絞り込みます。
		 */
		std::pair< mapIterator, mapIterator > range(const std::string &name);

		/**
		 * 進行待ち条件名で要素を絞り込みます。
		 */
		std::pair< const_mapIterator, const_mapIterator > range(const std::string &name) const;

	public:
		/**
		 * 進行待ち条件名に対応する最初の要素を指す反復子を取得します。
		 */
		mapIterator lower_bound(const std::string& name);

		/**
		 * 進行待ち条件名に対応する最初の要素を指す反復子を取得します。
		 */
		const_mapIterator lower_bound(const std::string& name) const;

	public:
		/**
		 * 進行待ち条件名より大きい最初の要素を指す反復子を取得します。
		 */
		mapIterator upper_bound(const std::string& name);

		/**
		 * 進行待ち条件名より大きい最初の要素を指す反復子を取得します。
		 */
		const_mapIterator upper_bound(const std::string& name) const;

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
